// file: bridge.c 
//
// Program for computing number of bridges of various lengths and heights

// system includes
#include <cstdio> 
using namespace std; 
#include "math.h"
#include <iostream>
using namespace std; 
#include <cstdlib>
#include "sys/time.h"
#include "time.h"
#include "limits.h"
#include <complex>
using namespace std;

// local includes
#include "local_constants.h"
#include "lib.h"
#include "point.h"
#include "rpoint.h"

int main()
{
point *bridge,step[4];
// nbridge[n][h]=# of bridges with n steps, height h
long nsteps,i[101],iup[101],j;
long nbridge[101][101];
long nir_bridge[101][101],ok,y,n,h,max_nsteps;
double etime,prob=0,mu;

mu=2.63815853031;

printf("enter max number of steps \n"); 
scanf("%ld",&max_nsteps);

step[0].assign(0,1);
step[1].assign(0,-1);
step[2].assign(1,0);
step[3].assign(-1,0);

for (j=0;j<4;j++) step[j].print(stdout);

bridge=new point[101];

for (n=0;n<=max_nsteps;n++) for(h=0;h<=max_nsteps;h++) nbridge[n][h]=0;

for (nsteps=1;nsteps<=max_nsteps;nsteps++) {

etime=-mytime();

bridge[0].assign(0,0);

for (j=1;j<=100;j++) iup[j]=1;
for (j=1;j<=nsteps;j++) iup[j]=4;

for (i[1]=0;i[1]<iup[1];i[1]++) {
bridge[1]=bridge[0]+step[i[1]];
ok=(bridge[1].coord_y_slow()>0);

if (ok) for (i[2]=0;i[2]<iup[2];i[2]++) {
bridge[2]=bridge[1]+step[i[2]];
if (nsteps>=2) ok=(bridge[2].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=2 && bridge[2]==bridge[0]) ok=0;

if (ok) for (i[3]=0;i[3]<iup[3];i[3]++) {
bridge[3]=bridge[2]+step[i[3]];
if (nsteps>=3) ok=(bridge[3].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=3 && bridge[3]==bridge[1]) ok=0;

if (ok) for (i[4]=0;i[4]<iup[4];i[4]++) {
bridge[4]=bridge[3]+step[i[4]];
if (nsteps>=4) ok=(bridge[4].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=4) {
    if (bridge[4]==bridge[2]) ok=0;
    if (bridge[4]==bridge[0]) ok=0;
}
if (ok) for (i[5]=0;i[5]<iup[5];i[5]++) {
bridge[5]=bridge[4]+step[i[5]];
if (nsteps>=5) ok=(bridge[5].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=5) {
    if (bridge[5]==bridge[3]) ok=0;
    if (bridge[5]==bridge[1]) ok=0;
}
if (ok) for (i[6]=0;i[6]<iup[6];i[6]++) {
bridge[6]=bridge[5]+step[i[6]];
if (nsteps>=6) ok=(bridge[6].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=6) {
    if (bridge[6]==bridge[4]) ok=0;
    if (bridge[6]==bridge[2]) ok=0;
    if (bridge[6]==bridge[0]) ok=0;
}
if (ok) for (i[7]=0;i[7]<iup[7];i[7]++) {
bridge[7]=bridge[6]+step[i[7]];
if (nsteps>=7) ok=(bridge[7].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=7) {
    if (bridge[7]==bridge[5]) ok=0;
    if (bridge[7]==bridge[3]) ok=0;
    if (bridge[7]==bridge[1]) ok=0;
}
if (ok) for (i[8]=0;i[8]<iup[8];i[8]++) {
bridge[8]=bridge[7]+step[i[8]];
if (nsteps>=8) ok=(bridge[8].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=8) {
    if (bridge[8]==bridge[6]) ok=0;
    if (bridge[8]==bridge[4]) ok=0;
    if (bridge[8]==bridge[2]) ok=0;
    if (bridge[8]==bridge[0]) ok=0;
}
if (ok) for (i[9]=0;i[9]<iup[9];i[9]++) {
bridge[9]=bridge[8]+step[i[9]];
if (nsteps>=9) ok=(bridge[9].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=9) {
    if (bridge[9]==bridge[7]) ok=0;
    if (bridge[9]==bridge[5]) ok=0;
    if (bridge[9]==bridge[3]) ok=0;
    if (bridge[9]==bridge[1]) ok=0;
}
if (ok) for (i[10]=0;i[10]<iup[10];i[10]++) {
bridge[10]=bridge[9]+step[i[10]];
if (nsteps>=10) ok=(bridge[10].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=10) {
    if (bridge[10]==bridge[8]) ok=0;
    if (bridge[10]==bridge[6]) ok=0;
    if (bridge[10]==bridge[4]) ok=0;
    if (bridge[10]==bridge[2]) ok=0;
    if (bridge[10]==bridge[0]) ok=0;
}
if (ok) for (i[11]=0;i[11]<iup[11];i[11]++) {
bridge[11]=bridge[10]+step[i[11]];
if (nsteps>=11) ok=(bridge[11].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=11) {
    if (bridge[11]==bridge[9]) ok=0;
    if (bridge[11]==bridge[7]) ok=0;
    if (bridge[11]==bridge[5]) ok=0;
    if (bridge[11]==bridge[3]) ok=0;
    if (bridge[11]==bridge[1]) ok=0;
}
if (ok) for (i[12]=0;i[12]<iup[12];i[12]++) {
bridge[12]=bridge[11]+step[i[12]];
if (nsteps>=12) ok=(bridge[12].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=12) {
    if (bridge[12]==bridge[10]) ok=0;
    if (bridge[12]==bridge[8]) ok=0;
    if (bridge[12]==bridge[6]) ok=0;
    if (bridge[12]==bridge[4]) ok=0;
    if (bridge[12]==bridge[2]) ok=0;
    if (bridge[12]==bridge[0]) ok=0;
}
if (ok) for (i[13]=0;i[13]<iup[13];i[13]++) {
bridge[13]=bridge[12]+step[i[13]];
if (nsteps>=13) ok=(bridge[13].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=13) {
    if (bridge[13]==bridge[11]) ok=0;
    if (bridge[13]==bridge[9]) ok=0;
    if (bridge[13]==bridge[7]) ok=0;
    if (bridge[13]==bridge[5]) ok=0;
    if (bridge[13]==bridge[3]) ok=0;
    if (bridge[13]==bridge[1]) ok=0;
}
if (ok) for (i[14]=0;i[14]<iup[14];i[14]++) {
bridge[14]=bridge[13]+step[i[14]];
if (nsteps>=14) ok=(bridge[14].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=14) {
    if (bridge[14]==bridge[12]) ok=0;
    if (bridge[14]==bridge[10]) ok=0;
    if (bridge[14]==bridge[8]) ok=0;
    if (bridge[14]==bridge[6]) ok=0;
    if (bridge[14]==bridge[4]) ok=0;
    if (bridge[14]==bridge[2]) ok=0;
    if (bridge[14]==bridge[0]) ok=0;
}
if (ok) for (i[15]=0;i[15]<iup[15];i[15]++) {
bridge[15]=bridge[14]+step[i[15]];
if (nsteps>=15) ok=(bridge[15].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=15) {
    if (bridge[15]==bridge[13]) ok=0;
    if (bridge[15]==bridge[11]) ok=0;
    if (bridge[15]==bridge[9]) ok=0;
    if (bridge[15]==bridge[7]) ok=0;
    if (bridge[15]==bridge[5]) ok=0;
    if (bridge[15]==bridge[3]) ok=0;
    if (bridge[15]==bridge[1]) ok=0;
}
if (ok) for (i[16]=0;i[16]<iup[16];i[16]++) {
bridge[16]=bridge[15]+step[i[16]];
if (nsteps>=16) ok=(bridge[16].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=16) {
    if (bridge[16]==bridge[14]) ok=0;
    if (bridge[16]==bridge[12]) ok=0;
    if (bridge[16]==bridge[10]) ok=0;
    if (bridge[16]==bridge[8]) ok=0;
    if (bridge[16]==bridge[6]) ok=0;
    if (bridge[16]==bridge[4]) ok=0;
    if (bridge[16]==bridge[2]) ok=0;
    if (bridge[16]==bridge[0]) ok=0;
}
if (ok) for (i[17]=0;i[17]<iup[17];i[17]++) {
bridge[17]=bridge[16]+step[i[17]];
if (nsteps>=17) ok=(bridge[17].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=17) {
    if (bridge[17]==bridge[15]) ok=0;
    if (bridge[17]==bridge[13]) ok=0;
    if (bridge[17]==bridge[11]) ok=0;
    if (bridge[17]==bridge[9]) ok=0;
    if (bridge[17]==bridge[7]) ok=0;
    if (bridge[17]==bridge[5]) ok=0;
    if (bridge[17]==bridge[3]) ok=0;
    if (bridge[17]==bridge[1]) ok=0;
}
if (ok) for (i[18]=0;i[18]<iup[18];i[18]++) {
bridge[18]=bridge[17]+step[i[18]];
if (nsteps>=18) ok=(bridge[18].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=18) {
    if (bridge[18]==bridge[16]) ok=0;
    if (bridge[18]==bridge[14]) ok=0;
    if (bridge[18]==bridge[12]) ok=0;
    if (bridge[18]==bridge[10]) ok=0;
    if (bridge[18]==bridge[8]) ok=0;
    if (bridge[18]==bridge[6]) ok=0;
    if (bridge[18]==bridge[4]) ok=0;
    if (bridge[18]==bridge[2]) ok=0;
    if (bridge[18]==bridge[0]) ok=0;
}
if (ok) for (i[19]=0;i[19]<iup[19];i[19]++) {
bridge[19]=bridge[18]+step[i[19]];
if (nsteps>=19) ok=(bridge[19].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=19) {
    if (bridge[19]==bridge[17]) ok=0;
    if (bridge[19]==bridge[15]) ok=0;
    if (bridge[19]==bridge[13]) ok=0;
    if (bridge[19]==bridge[11]) ok=0;
    if (bridge[19]==bridge[9]) ok=0;
    if (bridge[19]==bridge[7]) ok=0;
    if (bridge[19]==bridge[5]) ok=0;
    if (bridge[19]==bridge[3]) ok=0;
    if (bridge[17]==bridge[1]) ok=0;
}
if (ok) for (i[20]=0;i[20]<iup[20];i[20]++) {
bridge[20]=bridge[19]+step[i[20]];
if (nsteps>=20) ok=(bridge[20].coord_y_slow()>0);
else ok=1;
// check for intersections
if (nsteps>=20) {
    if (bridge[20]==bridge[18]) ok=0;
    if (bridge[20]==bridge[16]) ok=0;
    if (bridge[20]==bridge[14]) ok=0;
    if (bridge[20]==bridge[12]) ok=0;
    if (bridge[20]==bridge[10]) ok=0;
    if (bridge[20]==bridge[8]) ok=0;
    if (bridge[20]==bridge[6]) ok=0;
    if (bridge[20]==bridge[4]) ok=0;
    if (bridge[20]==bridge[2]) ok=0;
    if (bridge[20]==bridge[0]) ok=0;
}

// test if it is a bridge
y=bridge[nsteps].coord_y_slow();

for (j=1;j<=nsteps;j++) if (bridge[j].coord_y_slow()>y) ok=0;

if (ok) {
    nbridge[nsteps][0]++;
    nbridge[nsteps][y]++;
}

}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}

// compute number of irreducible bridges
nir_bridge[nsteps][0]=nbridge[nsteps][0];
for (n=1;n<nsteps;n++) 
    nir_bridge[nsteps][0]-=nir_bridge[n][0]*nbridge[nsteps-n][0];

for (h=1;h<=nsteps;h++) {
    nir_bridge[nsteps][h]=nbridge[nsteps][h];
    for (n=1;n<nsteps;n++) for (j=1;j<h;j++) 
        nir_bridge[nsteps][h]-=nir_bridge[n][j]*nbridge[nsteps-n][h-j];
}

prob+=pow(mu,-double(nsteps))*nir_bridge[nsteps][0];

// print 
printf(
  "nsteps=%2ld: bridges=%12ld, irred bridges=%12ld, %10.6lf secs %8.6lf\n",
  nsteps,nbridge[nsteps][0],nir_bridge[nsteps][0],mytime()+etime,prob);
FILE *fptr;
fptr=fopen("bridge.res","a");
fprintf(fptr,"nsteps=%2ld: bridges=%12ld, irred bridges=%12ld, %10.6lf secs\n",
     nsteps,nbridge[nsteps][0],nir_bridge[nsteps][0],mytime()+etime);
if (0) for (j=1;j<=20;j++) if (nbridge[nsteps][j]>0) 
    fprintf(fptr,"height=%2ld number =%ld \n",j,nbridge[nsteps][j]);

fprintf(fptr," %2ld  %10ld | ",nsteps,nbridge[nsteps][0]);
for (j=1;j<=20;j++) 
    if (nbridge[nsteps][j]>0) fprintf(fptr," %10ld",nbridge[nsteps][j]);
fprintf(fptr,"\n");

fprintf(fptr," %2ld  %10ld | ",nsteps,nir_bridge[nsteps][0]);
for (j=1;j<=20;j++) 
    if (nir_bridge[nsteps][j]>0) fprintf(fptr," %10ld",nir_bridge[nsteps][j]);
fprintf(fptr,"\n");

fclose(fptr);
} // end loop on nsteps
}




