// file name : src/excluded_class.h
//

#ifndef __excluded_class_hh
#define __excluded_class_hh

//////////////////////////////////////////////////////////////////////
//                       class  excluded_class                      //
//////////////////////////////////////////////////////////////////////

// excluded_class specifies the region the walk is excluded from.
// In the case of projecting the 3d walk onto 2d, it also specifies
// the x and y directions for the plane onto which we project.

class excluded_class {
 private:
 public:
  // region specifies the region the walk is excluded from
  // =0 : no excluded region, full plane 
  // =1 : half plane, walk must satisfy y>0
  // =2 : cut: walk not allowed to hit positive x-axis
  // =3 : quarter: walk not allowed to hit pos x-axis or pos y-axis
  // =4 : exterior of a disc: used by LERW
  long region;
  // xn and yn are unit vectors that define the x and y directions for the
  //   plane we project onto
  // We don't input xn and yn directly. They are defined by three angles 
  // theta, phi, xphi (one angle in two dims). 
  // After the angles are read in, xn and yn are computed.
  // This is done in parameters::scan()
  rpoint xn,yn;
  // for region=4, following specify the disk
  double radius;
  rpoint center;
}; // end class excluded_class {

#endif

///////////////////////////////////////////////////////////////
//  checkk checkk checkk checkk checkk checkk checkk checkk  //
///////////////////////////////////////////////////////////////
