// file: src/line.c 
//
// This program simply creates a walk that is a straight line and 
// writes it to a file. 
// 

// system includes
#include <cstdio> 
using namespace std; 
#include "math.h"
#include <iostream>
using namespace std; 
#include <cstdlib>
#include "sys/time.h"
#include "time.h"
#include "limits.h"
#include <complex>
using namespace std;

#define I complex<double>(0.,1.);

// local includes 
#include "local_constants.h"
#include "rpoint.h"
#include "parameters.h"
#include "excluded_class.h"
#include "derived_parameters.h"
#include "rwalk.h"
#include "walk.h"

int main()
{
parameters parm;
walk w;
char inname[101];
long direction;

FILE *fptr;

printf("Enter file name for input file  \n");
scanf("%s",inname);
printf("Input file is  %s \n",inname);

printf("Enter direction, 1=horizontal, 2=45 degs, 3=vertical, 4=60 degs \n");
printf("  10=two at angles +-45\n");
scanf("%ld",&direction);

fptr=fopen(inname,"r");
parm.scan(fptr);
fclose(fptr);
parm.print(stdout);

/////////////////////////////////////////////////////////////////
//                    allocate memory                          //
/////////////////////////////////////////////////////////////////
w.allocate(parm.nsteps);
parm.print(stdout);

////////////////////////////////////////////////////////////
//      initialize walk to a straight line                //
////////////////////////////////////////////////////////////
if (direction<10) w.line_initialize(direction);
#ifdef TWO_DIMENSIONS
else w.two_line_initialize(direction);
#endif

////////////////////////////////////////////////////////////
//             write walk to file                         //
////////////////////////////////////////////////////////////
fptr=fopen(parm.init_fname,"r");
if (fptr!=NULL) {
    printf("File %s exists, will not overwrite it \n",parm.init_fname) ;
    exit(1);
    } 

fptr=fopen(parm.init_fname,"w");
if (fptr==NULL) {
    printf("File %s \n",parm.init_fname); 
    printf(" could not be opened (could be a lack of walks/ directory \n");
    exit(0);
    } 
w.print(fptr);
fclose(fptr);

} // end main 

///////////////////////////////////////////////////////////////
//  checkk checkk checkk checkk checkk checkk checkk checkk  //
///////////////////////////////////////////////////////////////
