// rwalk.c : header file for class rwalk 

#ifndef __rwalk_hh
#define __rwalk_hh

class rpoint;
class point;
class walk;

class rwalk {
// stores a single walk consisting of rpoints. Used by LERW
 private: 
 public:
  // steps and nsteps were private
  rpoint* steps;
  long nsteps; // number of steps in the walk  

  int allocate(long n);
  void deallocate(); 
  void initialize(); 
  long get_nsteps();
  void set_nsteps(long n);
  rpoint step_rval(long i);
  void assign_step(long i,rpoint pt);
  void print(FILE *fptr);
  void scan(FILE *fptr);
  void plot(FILE *fptr);
  void plot_projected(FILE* fptr,double rrho);
  void time_reverse();
  void rotate(double theta); 
  void rescale(double c); 
  void conformal_map(excluded_class* excluded);
  double ymax();
  double theta();
  rwalk& operator=(walk& w);
  void interpolate(long ninterp);
}; 
#endif

///////////////////////////////////////////////////////////////
//  checkk checkk checkk checkk checkk checkk checkk checkk  //
///////////////////////////////////////////////////////////////
